<html>
<head><title>Books</title></head>
<body>
<dl>
<?php
$author = array();
$publisher = array();
$reader = new XmlReader();
$reader->open($argv[1]);
while($reader->read()) {
	if ($reader->nodeType == XMLReader::ELEMENT) {
		switch($reader->name) {
		case 'author':
			read_author($reader); break;
		case 'book':
			read_book($reader); break;
		}
	}
}

function read_author($reader) {
	global $author;
	if (!$reader->isEmptyElement) {
		$id = $reader->getAttribute('id');
		$reader->read();
		$author[$id] = $reader->value;
	}
}

function read_book($reader) {
	global $author;
	$id = $reader->getAttribute('author');
	echo "<dt>" . get_text($reader) . "</dt>\n";
	echo "<dd>Author: " . $author[$id] . "</dd>\n";
}

function get_text($r) {
	$t = '';
	$l = $r->depth;
	while($r->read() && ($r->depth > $l || $r->nodeType != XMLReader::END_ELEMENT)) {
		if ($r->nodeType == XMLReader::TEXT) {
			$t .= $r->value;
		}
	}
	return trim($t);
}
?>
</dl>
</body>
</html>